<template>
  <div class="news-card">
    <div class="card-img">
      <img class="img-style" :src="getImage" alt="img" />
    </div>
    <div class="card-content">
      <div class="content-padding">
        <h4>
          {{ getContent }}
        </h4>
        <p class="source">{{ data.source.name }}</p>
        <p class="description">
          {{ data.description }}
        </p>
        <div class="flag-section flex align-items">
          <div class="page-btn">
            <button @click="detailPage(data.u_id)">Go to page</button>
          </div>
          <div class="bookmark-flag" @click="handleBookmarks">
            <i :class="themeChange"></i>
          </div>
        </div>
      </div>
    </div>
    <div class="card-footer flex align-items">
      <p>Published : {{ calculateDate(data.publishedAt) }}</p>
    </div>
  </div>
</template>
<script>
import { mapGetters } from "vuex";
export default {
  name: "NewsCard",
  props: ["data"],
  data() {
    return {
      NotFoundImage:
        "https://media1.tenor.com/images/fecaec2ec07ebe4330471c927f851cdf/tenor.gif?itemid=13047874",
    };
  },
  computed: {
    ...mapGetters({
      bookmarkResults: "BookMarksData",
    }),
    getContent() {
      return this.data.content
        ? this.data.content
        : "Lorem Ipsum is simply dummy text of the printing and typesetting industry";
    },
    themeChange() {
      return this.bookmarkResults.find(
        (value) => JSON.stringify(value) == JSON.stringify(this.data)
      )
        ? "fa-solid fa-bookmark"
        : "fa-regular fa-bookmark";
    },
    getImage() {
      return this.data.urlToImage ? this.data.urlToImage : this.NotFoundImage;
    },
    calculateDate() {
      return (value) => {
        const dateFormate = new Date(value);
        return `${dateFormate.getFullYear()}/${(
          "0" + dateFormate.getMonth()
        ).slice(-2)}/${("0" + dateFormate.getDate()).slice(-2)}`;
      };
    },
  },
  methods: {
    handleBookmarks() {
      if (
        !this.bookmarkResults.find(
          (value) => JSON.stringify(value) == JSON.stringify(this.data)
        )
      ) {
        this.$store.dispatch("AddBookmarks", this.data);
      } else {
        this.$store.dispatch("RemoveBookmarks", this.data);
      }
    },
    detailPage(value) {
      this.$router.push({ name: "detailPage", params: { id: value } });
    },
  },
};
</script>
<style scoped>
.news-card {
  width: 32%;
  background-color: #f7f7f7;
  height: 620px;
  border-radius: 0.5rem;
}

.card-img {
  height: 45%;
}

.img-style {
  height: 100%;
  width: 100%;
  border-top-left-radius: 0.5rem;
  border-top-right-radius: 0.5rem;
}

.card-content {
  background-color: white;
  height: 45%;
}

.content-padding {
  padding: 1.5rem;
}

.content-padding > h4 {
  overflow: hidden;
  text-overflow: ellipsis;
  display: -webkit-box;
  line-height: 26px;
  -webkit-line-clamp: 2; /* number of lines to show */
  -webkit-box-orient: vertical;
  color: #42474b;
  font-size: 20px;
}

.content-padding .source {
  font-size: 20px;
  font-weight: 500;
  color: #7c7e86;
  margin-top: 10px;
  margin-bottom: 5px;
}

.content-padding .description {
  overflow: hidden;
  text-overflow: ellipsis;
  display: -webkit-box;
  line-height: 25px;
  -webkit-line-clamp: 3; /* number of lines to show */
  -webkit-box-orient: vertical;
  color: #343a40;
  font-family: system-ui;
  font-size: 16px;
  margin-top: 5px;
  margin-bottom: 5px;
}

.flag-section {
  margin-top: 15px;
  margin-bottom: 5px;
  justify-content: space-between;
  font-size: 25px;
}

.flag-section button {
  background: #343a40;
  color: white;
  padding: 0.6rem;
  border: none;
  border-radius: 0.3rem;
  font-size: 15px;
  cursor: pointer;
}

.flag-section i {
  cursor: pointer;
}

.card-footer {
  height: 10%;
  padding: 1.5rem;
  box-sizing: border-box;
  border-top: 1px solid gray;
}

.card-footer > p {
  color: #999998;
}
</style>
